/*
 *
 *
 * aj ked jednoduchsia ale ucinnejsia verzia ukladania podkociek
 *
 *
 */
#include<iostream>
#include<fstream>
#include<cstdlib>
#include<ctime>
#include"stopky.h"
using namespace std;

#define ULL unsigned long
#define POKUSY_TRAFIT_BITY 100
#define KEDY_LOG 100000

struct podKocka{ // {{{
   short int velkost,pevnychB;
   ULL bity;
   ULL maska;
}; // }}}
struct komponent{ //{{{
   short int pocetCasti,pocetPlnych;
   podKocka *cast;
} *komp; //}}}

ULL mocniny[33];
long n,m,m1,k;
bool zacniKomponent(long x);
bool ulozCast(long podK,long kom);
string iTb(ULL x);
void ulozKocky(string menoSuboru);

int main(int argc,char *args[]){
// deklaracie: {{{
   long seed=time(NULL);
   cout<<"seed: "<<seed<<endl;
   srand(seed);
   long i,j,l,p,maxK=0,maxPK=0;
   long long kroky=0;
   bool ok;
   Stopky stopky;
   string logS="log00";
   mocniny[0]=1;
   for(i=1;i<32;i++) mocniny[i]=mocniny[i-1]*2;
//}}}
// nastavenie parametrov a komponentov {{{
   if(argc>1)logS=(string)args[1];
   if(argc>2)n = atoi(args[2]);
   else{ cout<<"n?: "<<endl; cin>>n; }
   if((n<3)||(n>=32)){cout<<"Zly rozmer."<<endl; return 1; }
   if(argc>3)k = atoi(args[3]);
   else{ cout<<"k?: "<<endl; cin>>k; }
   if((k<2)||(k>1048576)){cout<<"Zly pocet casti."<<endl; return 2; }
   m=mocniny[n];
   m1=m/k;
   p=0;
   for(i=0;i<32;i++) if((mocniny[i]&m1)>0)p++;
   komp=new komponent[k];
   for(i=0;i<k;i++){
      komp[i].pocetCasti=p;
      komp[i].pocetPlnych=0;
      komp[i].cast=new podKocka[p];
      l=0;
      for(j=31;j>=0;j--)if((mocniny[j]&m1)>0){
         komp[i].cast[l].velkost=j;
         l++;
      }
   }
// {{{
/*
   for(i=0;i<k;i++){
      cout<<komp[i].pocetCasti<<" "<<komp[i].pocetPlnych<<endl;
      for(j=0;j<komp[i].pocetCasti;j++){
         cout<<" "<<komp[i].cast[j].velkost<<" == "<<mocniny[komp[i].cast[j].velkost]<<endl;
      }
   }
*/ //}}}
// }}}
// Umiestnenie prvej podkocky: {{{   
   komp[0].cast[0].bity=0;
   komp[0].cast[0].pevnychB=n-komp[0].cast[0].velkost;
   for(i=0;i<komp[0].cast[0].pevnychB;i++)komp[0].cast[0].maska+=mocniny[i];
//}}}
   stopky.start();
   while(1){
      kroky++;
      if(kroky%KEDY_LOG == 0){
         cout<<"Uz to skusam "<<kroky<<" krat."<<endl;
         stopky.medzicas();
      }
      ok=true;
      komp[0].pocetPlnych=1;
      for(i=1;(i<k) && ok;i++){
         if((maxPK==0)&&(i-1>maxK)){
            maxK=i-1;
            cout<<"Nove maximum:: cast: "<<maxPK<<"  komponent: "<<maxK<<endl;
            stopky.medzicas();
            ulozKocky(logS);
         }
         ok=zacniKomponent(i);
      }
      if(!ok)continue;
      for(i=1;i<p;i++){
         for(j=0;j<k;j++){
            if(!ulozCast(i,j))break;
            if((i>maxPK)||((i==maxPK)&&(j>maxK))){
               maxPK=i;
               maxK=j;
               cout<<"Nove maximum:: cast: "<<maxPK<<"  komponent: "<<maxK<<endl;
               ulozKocky(logS);
               stopky.medzicas();
            }
         }
         if(j<k){
//            cout<<"Skoncilo na komponente: "<<j<<endl;
//            cout<<"Zaciname odznova ..."<<endl;
            break;
         }
      }
      if(i==p){
         cout<<"Podarilo sa ulozit vsetko."<<endl;
         stopky.stop();
         return 0;
      }
   }
   return 0;
}


bool ulozCast(long podK,long kom){//{{{
   ULL bityZaklad=0,mZaklad,maskaRozdiel,bity,maska,b;
   long i,ii,iii,j,l;
   mZaklad=komp[kom].cast[podK-1].maska;
   bityZaklad=mZaklad & komp[kom].cast[podK-1].bity;
   if(podK>=2)maskaRozdiel = mZaklad ^ komp[kom].cast[podK-2].maska;
   else maskaRozdiel = mZaklad;
   for(i=0;i<n;i++)if((mocniny[i]&maskaRozdiel)>0){
   //tuna skusam menit jednotlive bity postupne, mozno by to bolo dobre znahodnit
      bity=bityZaklad^mocniny[i];
      for(ii=0;ii<POKUSY_TRAFIT_BITY;ii++){
         maska=mZaklad;
         for(j=0;j<komp[kom].cast[podK-1].velkost-komp[kom].cast[podK].velkost;j++){
            do{ l=rand()%(n); }while((mocniny[l]&maska)!=0);
            maska=maska|mocniny[l];
         }
         for(iii=0;iii<POKUSY_TRAFIT_BITY;iii++){
            b=(((rand()%mocniny[n]) & ( ~ mZaklad )) & maska ) ^ bity;
            //b by malo obsahovat zakladne bity s jednym invertovanym 
            //  okrem toho by ostatne bity mali byt platne len ak su pod maskou s tym ze su nahodne
            //uz len overit ci je to OK
            for(j=0;j<k;j++){
               if(j==kom)continue;
               for(l=0;l<komp[j].pocetPlnych;l++){//treba porozmyslat ci naozaj treba kontrolovat vsetky casti vsetkych komponentov
                  if(0 == ((komp[j].cast[l].bity & komp[j].cast[l].maska & maska) ^ (komp[j].cast[l].maska & b )))
                     break;
               }
               if(l<komp[j].pocetPlnych)break;
            }
            if(j==k)break;
         }
         if(iii<POKUSY_TRAFIT_BITY){
            komp[kom].cast[podK].bity=b;
            komp[kom].cast[podK].maska=maska;
            komp[kom].pocetPlnych++;
            return true;
         }
      }
   }
   return false;
}//}}}

bool zacniKomponent(long x){//{{{
   ULL maska=0;
   podKocka *cast;
   cast=komp[x].cast;
   long i,j,b,ii;
   bool dobraMaska;
   cast->pevnychB=n-cast->velkost;
   for(ii=0;ii<POKUSY_TRAFIT_BITY;ii++){
      maska=0;
      for(i=0;i<cast->pevnychB;i++){
         do{ b=rand()%n; }while((maska&mocniny[b])>0);
         maska=maska|mocniny[b];
      }
      dobraMaska=true;
      for(i=0;i<POKUSY_TRAFIT_BITY;i++){
         b=(rand()%mocniny[n]) & maska;
         for(j=0;j<x;j++){
            if((komp[j].cast[0].maska & maska) == 0){ dobraMaska=false; break; }
            //nasledujuci if: ci aspon nejake platne bity su rozne
            if(0 == ((komp[j].cast[0].bity & komp[j].cast[0].maska & maska) ^ (komp[j].cast[0].maska & b )))
               break;
         }
         if((j==x)||(! dobraMaska))break;
      }
      if(! dobraMaska) continue;
      if(i<POKUSY_TRAFIT_BITY){
         cast->maska = maska;
         cast->bity = b;
         komp[x].pocetPlnych=1;
         return true;
      }
   }
   return false;
}//}}}

void ulozKocky(string menoSuboru){//{{{
   ofstream logS((menoSuboru+".log").c_str()),datS((menoSuboru+".dat").c_str());
   long i,j;
   logS<<"n: "<<n<<" k:"<<k<<endl<<"----------"<<endl;
   datS<<n<<" "<<k<<endl<<endl;
   for(i=0;i<k;i++){
      logS<<"Komponent: "<<i<<endl;
      logS<<"   casti: "<<komp[i].pocetCasti<<"   plnych: "<<komp[i].pocetPlnych<<endl;
      datS<<i<<"   "<<komp[i].pocetPlnych<<endl;
      for(j=0;j<komp[i].pocetPlnych;j++){
         logS<<"   Cast: "<<j<<"   velkost: "<<komp[i].cast[j].velkost<<" -> "<<mocniny[komp[i].cast[j].velkost]<<endl;
         logS<<"      maska: "<<iTb(komp[i].cast[j].maska)<<endl;
         logS<<"      bity:  "<<iTb(komp[i].cast[j].bity)<<endl;
         datS<<"   "<<komp[i].cast[j].velkost<<"   "<<komp[i].cast[j].maska<<" "<<komp[i].cast[j].bity<<endl;
      }
   }
   logS.close();
   datS.close();
}//}}}
string iTb(ULL x){//{{{
   string ret="";
   for(int i=n-1;i>=0;i--){
      if((x&mocniny[i])>0)ret+="1";
      else ret+="0";
   }
   return ret;
}//}}}


// vim: fdm=marker:commentstring=\ //\ %s
