/*
 *
 * simulovane zihanie
 * prva verzia
 *
 *
 */
#include<iostream>
#include<fstream>
#include<sstream>
#include<cstdlib>
#include<ctime>
#include<cmath>
#include"stopky.h"
using namespace std;

#define PAZRAVOST 0.9
#define KONTROLA 1000000
#define MAX_NEMENNYCH 5
#define NEZMENSOVAT_TEPLOTU_POD 0.3
long mocniny[33];
char *vrcholy;
long *casti,*pouzite;

double teploty[]={4.0,1.5,1.2,1.1,1.0,3.0,1.5,1.2,1.1,1.0,2.0,1.5,1.2,1.1,1.0,1.2,1.1,1.2,1.1,1.0,1.0,1.0,1.0,5.0,1.5,1.5,1.5,1.2,2.0,1.0};
long nT=20;

long long ratajHrany(long n,long m,long k);
long *okolie(long n,long v);
void priradPostupne(long m,long k);
void priradPazravo2(long n,long m,long k);
void priradNahodne(long m,long k);

int main(){
// deklaracie: {{{
   long seed=time(NULL);
   cout<<"seed: "<<seed<<endl;
   srand(seed);
   long i,n,k,m,vCast,navyse,a,b,x,vymen,volba,nemenne,iT,logCislo;
   long long hran,hran2,hran3,najlepsie,kroky;
   double t,dec,dec0;
   Stopky stopky;
   string logSubor,casLog;
   ofstream log;
// teploty: {{{
   ifstream teplotyIn("teploty.txt");
   if(! teplotyIn.fail()){
      teplotyIn>>nT;
      if(nT>30)nT=30;
      for(i=0;i<nT;i++)teplotyIn>>teploty[i];
      teplotyIn.close();
   }
//}}}
// mocniny: {{{
   mocniny[0]=1;
   for(i=1;i<=32;i++) mocniny[i]=mocniny[i-1]*2;
//}}}
//}}}
// parametre: {{{
   cout<<"n?: "<<endl; cin>>n;
   cout<<"k?: "<<endl; cin>>k;
// otvorenie log streamu: {{{
   ostringstream ossLog;
   cout<<"Log subor cislo?: ";
   cin>>logCislo;
   ossLog<<"log_"<<n<<"_"<<k<<"_"<<logCislo<<".log";
   logSubor=ossLog.str();
   log.open(logSubor.c_str());
//}}}
   m=mocniny[n];
   vCast=m/k;
   navyse=m%k;
   cout<<"vrcholov: "<<m<<endl<<"v jednej casti: "<<vCast<<endl<<"navyse: "<<navyse<<endl;
   vrcholy=new char[m];
   casti=new long[k];
   pouzite=new long[k];
   for(i=0;i<k;i++){
      casti[i]=vCast;
      pouzite[i]=0;
      if(i<navyse)casti[i]++;
   }
//}}}
//priradenie: {{{
   cout<<"postupne - 1  pazravo - 2  nahodne - 3 ?: ";
   cout<<"POSTUPNE"<<endl;
   volba=1;
//   cin>>volba;
   stopky.start();
   switch(volba){
      case 1: priradPostupne(m,k); break;
      case 2: priradPazravo2(n,m,k); break;
      default: priradNahodne(m,k);
   }
   stopky.stop();
   cout<<"counting..."<<endl;
   hran=ratajHrany(n,m,k);
   najlepsie=hran;
   cout<<"hran: "<<hran<<endl<<"delene pocet vrcholov: "<<((double)hran/m)<<endl;
//}}}
   cout<<"zmensenie?: 0.9999999"<<endl;
//   cin>>dec0;
   dec0=0.9999999;
   for(iT=0;iT<nT;iT++){
      dec=dec0;
      t=teploty[iT];
      cout<<"teplota: "<<t<<"  zmensenie: "<<dec<<endl;
      log<<"teplota: "<<t<<"  zmensenie: "<<dec<<endl;
      kroky=0;
      vymen=0;
      hran3=0;
      nemenne=0;
      stopky.start();
      while(nemenne<=MAX_NEMENNYCH){
         hran2=hran;
         // vyber a ohodnot dvojicu
         a=rand()%m;
         do{b=rand()%m;}while(vrcholy[b]==vrcholy[a]);
         for(i=0;i<n;i++){
            x=a^mocniny[i];
            if(x!=b){
               if(vrcholy[b]==vrcholy[x])hran2-=2;
               else if(vrcholy[a]==vrcholy[x])hran2+=2;
               x=b^mocniny[i];
               if(vrcholy[a]==vrcholy[x])hran2-=2;
               else if(vrcholy[b]==vrcholy[x])hran2+=2;
            }
         }
         // rozhodni ci sa dvojica vymeni
         if((hran2<hran)||
            ( (double)rand()/RAND_MAX < exp( ((double) hran - hran2) / t ) )){
            if(hran2>hran)t*=dec;
            else if(hran2<najlepsie)najlepsie=hran2;
            hran=hran2;
            x=vrcholy[a];
            vrcholy[a]=vrcholy[b];
            vrcholy[b]=x;
            vymen++;
         }else { t*=dec; }
         kroky++;
         if(kroky%KONTROLA==0){
            cout<<"  po "<<kroky<<" krokoch: "<<vymen<<" vymen";
            if(nT-iT==3)cout<<"   !!!";
            if(nT-iT==2)cout<<"   !!";
            if(nT-iT==1)cout<<"   !";
            cout<<endl;
            cout<<"     teplota: "<<t<<"\n     hran: "<<hran<<" delene pocet vrcholov: "<<((double)hran/m)<<endl;
            if(hran3==hran)nemenne++;
            else nemenne=0;
            hran3=hran;
            if(t<NEZMENSOVAT_TEPLOTU_POD)dec=1;
         }
      }
      cout<<" najlepsie: "<<najlepsie<<endl<<"  delene pocet vrcholov: "<<(double)najlepsie/m<<endl;
      cout<<" hran: "<<hran<<endl<<"  delene pocet vrcholov: "<<((double)hran/m)<<endl;
      cout<<"    ";
      casLog=stopky.stop();
      cout<<"    krokov: "<<kroky<<" vymen: "<<vymen<<endl<<endl;
      log<<" najlepsie: "<<najlepsie<<endl<<"  delene pocet vrcholov: "<<(double)najlepsie/m<<endl;
      log<<" hran: "<<hran<<endl<<" delene pocet vrcholov: "<<((double)hran/m)<<endl;
      log<<"     "<<casLog;
      log<<"     krokov: "<<kroky<<" vymen: "<<vymen<<endl<<endl;
   }
   cout<<endl<<"NAJLEPSIE: "<<najlepsie/2<<"   delene pocet vrcholov: "<<((double)najlepsie/m)/2.0<<endl;
   log<<endl<<"NAJLEPSIE: "<<najlepsie/2<<"   delene pocet vrcholov: "<<((double)najlepsie/m)/2.0<<endl;
   log.close();
   return 0;
}

void priradPazravo2(long n,long m,long k){//{{{
// greedy priradenie dava rovnako dobre vysledky ako nahodne priradenie
   long fBest[k],fUsed[k];
   long i,j,x,f;
   for(i=0;i<k;i++){
      pouzite[i]=0;
      fUsed[i]=-47;
   }
   for(i=0;i<m;i++)vrcholy[i]=-47;
   for(i=0;i<m*PAZRAVOST;i++){
      do{ x=rand()%m; }while(vrcholy[x]!=-47);
      for(j=0;j<n;j++){
         f=vrcholy[x^mocniny[j]];
         if(f!=-47){
            if(fUsed[f]==x)fBest[f]++;
            else{
               fBest[f]=1;
               fUsed[f]=x;
            }
         }
      }
      f=0;
      for(j=0;j<k;j++){
         if(((pouzite[f]>=casti[f])&&(pouzite[j]<casti[j]))||
            (((fUsed[j]==x)&&
             ((fUsed[f]!=x)||
              (fBest[f]<fBest[j])||
              ((fBest[f]==fBest[j])&&(pouzite[f]>pouzite[j])))))){
            f=j;
         }
      }
      pouzite[f]++;
      vrcholy[x]=f;
   }
   for(i=0;i<m;i++){
      if(vrcholy[i]==-47){
         x=i;
         for(j=0;j<n;j++){
            f=vrcholy[x^mocniny[j]];
            if(f!=-47){
               if(fUsed[f]==x)fBest[f]++;
               else{
                  fBest[f]=1;
                  fUsed[f]=x;
               }
            }
         }
         f=0;
         for(j=0;j<k;j++){
            if((pouzite[j]<casti[j])&&
               ((pouzite[f]>=casti[f])||
                (((fUsed[j]==x)&&
                 ((fUsed[f]!=x)||
                  (fBest[f]<fBest[j])||
                  ((fBest[f]==fBest[j])&&(pouzite[f]>pouzite[j]))))))){
               f=j;
            }
         }
         pouzite[f]++;
         vrcholy[x]=f;
      }
   }
}//}}}
void priradPostupne(long m,long k){//{{{
// postupne priradenie vrcholov
   long f,i;
   f=0;
   for(i=0;i<k;i++)pouzite[i]=0;
   for(i=0;i<m;i++){
      if(pouzite[f]>=casti[f])f++;
      vrcholy[i]=f;
      pouzite[f]++;
   }
}//}}}
void priradNahodne(long m,long k){//{{{
   long f,i;
   for(i=0;i<k;i++)pouzite[i]=0;
   for(i=0;i<m;i++){
      do{ f=rand()%k; }while(pouzite[f]>=casti[f]);
      vrcholy[i]=f;
      pouzite[f]++;
   }
}//}}}
long long ratajHrany(long n,long m,long k){//{{{
// zratanie hran a kontrola
   long long hran=0;
   long i,j,*komp=new long[k];
   for(i=0;i<k;i++)komp[i]=0;
   for(i=0;i<m;i++){
      if(vrcholy[i]==-47)cout<<"CHYBA 2: vrchol "<<i<<" je nevyplneny!"<<endl;
      else{
         komp[vrcholy[i]]++;
         for(j=0;j<n;j++)if( vrcholy[i] != vrcholy[i^mocniny[j]] )hran++;
      }
   }
   for(i=0;i<k;i++)if(komp[i]!=casti[i]){
      cout<<"CHYBA 3: komponent "<<i<<" -> je ich: "<<komp[i]<<" vraj : "<<pouzite[i]<<" ma byt: "<<casti[i]<<endl;
   }
   return hran;
}//}}}

// vim: fdm=marker:commentstring=\ //\ %s
